import _getIterator from 'babel-runtime/core-js/get-iterator';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import React from 'react';
import { cloneDeep } from 'lodash';

export var FieldAttr = function () {
  function FieldAttr(instance) {
    var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    var value = arguments[2];
    var validators = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
    var validatorsOptions = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    var asyncValidator = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;
    var asyncValidatorOptions = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : {};

    _classCallCheck(this, FieldAttr);

    this.name = '';
    this.value = '';
    this.validators = [];
    this.validatorsOptions = {};
    this.asyncValidator = null;
    this.asyncValidatorOptions = {};
    this.errors = [];
    this.asyncErrors = [];
    this.touched = false;
    this.dirty = false;
    this.pristine = true;
    this.focused = false;
    this.pending = false;

    this.instance = instance;
    this.name = name;
    this.value = value;
    this.validators = validators;
    this.validatorsOptions = validatorsOptions;
    this.asyncValidator = asyncValidator;
    this.asyncValidatorOptions = asyncValidatorOptions;
  }

  FieldAttr.prototype.setValue = function setValue() {
    var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

    this.value = value;
  };

  FieldAttr.prototype.setValidators = function setValidators() {
    var validators = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    this.validators = validators;
  };

  FieldAttr.prototype.setValidatorsOptions = function setValidatorsOptions() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    this.validatorsOptions = options;
  };

  FieldAttr.prototype.setAsyncValidator = function setAsyncValidator(validator) {
    this.asyncValidator = validator;
  };

  FieldAttr.prototype.setAsyncValidatorOptions = function setAsyncValidatorOptions() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    this.asyncValidatorOptions = options;
  };

  FieldAttr.prototype.setErrors = function setErrors() {
    var errors = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    this.errors = errors;
  };

  FieldAttr.prototype.setDirty = function setDirty(dirty) {
    this.dirty = !!dirty;
    this.pristine = !dirty;
  };

  FieldAttr.prototype.setTouched = function setTouched(touched) {
    this.touched = !!touched;
  };

  FieldAttr.prototype.setFocus = function setFocus(focused) {
    this.focused = !!focused;
  };

  FieldAttr.prototype.validate = function validate() {
    var validators = this.validators,
        name = this.name,
        value = this.value;
    var _validatorsOptions$mu = this.validatorsOptions.multi,
        multi = _validatorsOptions$mu === undefined ? true : _validatorsOptions$mu;

    if (multi) {
      var errors = validators.map(function (v) {
        return !v.isValid(value) && v.error(name, value);
      }).filter(function (v) {
        return v;
      });
      this.setErrors(errors);
    } else {
      this.setErrors([]);
      for (var _iterator = validators, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _getIterator(_iterator);;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var v = _ref;

        if (!v.isValid(value)) {
          this.setErrors([v.error(name, value)]);
          break;
        }
      }
    }
  };

  FieldAttr.prototype.asyncValidate = function asyncValidate(currentEvent, done) {
    var _this = this;

    if (currentEvent && currentEvent === FieldAttr.events.CHANGE) {
      // need to clear when user input text to hide errors
      this.asyncErrors = [];
    }
    var asyncValidator = this.asyncValidator,
        asyncValidatorOptions = this.asyncValidatorOptions,
        errors = this.errors;
    var _asyncValidatorOption = asyncValidatorOptions.validateOn,
        validateOn = _asyncValidatorOption === undefined ? [] : _asyncValidatorOption,
        _asyncValidatorOption2 = asyncValidatorOptions.validateAfterLocal,
        validateAfterLocal = _asyncValidatorOption2 === undefined ? false : _asyncValidatorOption2;

    if (validateAfterLocal && errors.length) {
      return done();
    }
    if (asyncValidator) {
      if (validateOn.length && validateOn.indexOf(currentEvent) === -1) {
        return done();
      }
      this.pending = true;
      asyncValidator(this.getFieldOptions()).then(function () {
        _this.pending = false;
        _this.asyncErrors = [];
        done(true);
      })['catch'](function (errors) {
        _this.pending = false;
        _this.asyncErrors = errors || [];
        done(true);
      });
    } else {
      done();
    }
  };

  FieldAttr.prototype.getFieldOptions = function getFieldOptions() {
    return cloneDeep({
      name: this.name,
      focused: this.focused,
      touched: this.touched,
      dirty: this.dirty,
      pristine: this.pristine,
      value: this.value,
      pending: this.pending,
      errors: this.errors,
      asyncErrors: this.asyncErrors,
      isValid: !this.errors.length && !this.asyncErrors.length
    });
  };

  return FieldAttr;
}();
FieldAttr.events = {
  FOCUS: 'focus',
  CHANGE: 'change',
  BLUR: 'blur'
};