'use strict';

exports.__esModule = true;
exports.Field = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

var _fields = require('./fields');

var _fieldProps = require('./field-props');

var _fieldAttr = require('./field-attr');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Field = function (_React$Component) {
  (0, _inherits3.default)(Field, _React$Component);

  function Field(props) {
    (0, _classCallCheck3.default)(this, Field);

    var _this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call(this, props));

    _this.onFocus = function () {
      return _this.__onFocus__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onBlur = function () {
      return _this.__onBlur__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.onChange = function () {
      return _this.__onChange__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.validate = function () {
      return _this.__validate__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.reset = function () {
      return _this.__reset__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.updateState = function () {
      return _this.__updateState__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.field = _this.createField();
    _this.validateField();
    _this.state = {
      value: _this.field.value
    };
    return _this;
  }

  Field.prototype.componentDidMount = function componentDidMount() {
    var _props$onInit = this.props.onInit,
        onInit = _props$onInit === undefined ? function () {} : _props$onInit;

    onInit(this.field);
  };

  Field.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var changed = false;
    var validate = false;
    if (this.props.value !== nextProps.value) {
      this.field.setValue(nextProps.value);
      this.updateState();
      changed = true;
      validate = true;
    }
    if (!(0, _lodash.isEqual)(this.props.validators, nextProps.validators)) {
      this.field.setValidators(nextProps.validators);
      this.field.setValidatorsOptions(nextProps.validatorsOptions);
      changed = true;
      validate = true;
    }
    if (!(0, _lodash.isEqual)(this.props.asyncValidator, nextProps.asyncValidator)) {
      this.field.setAsyncValidator(nextProps.asyncValidator);
      this.field.setAsyncValidatorOptions(nextProps.asyncValidatorOptions);
      changed = true;
      validate = true;
    }
    if (validate) {
      this.validateField();
    }
    if (changed) {
      var _nextProps$onUpdate = nextProps.onUpdate,
          onUpdate = _nextProps$onUpdate === undefined ? function () {} : _nextProps$onUpdate;

      onUpdate(this.field);
    }
  };

  Field.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    return !(0, _lodash.isEqual)(this.props, nextProps) || !(0, _lodash.isEqual)(this.state, nextState);
  };

  Field.prototype.componentWillUnmount = function componentWillUnmount() {
    var _props$onRemove = this.props.onRemove,
        onRemove = _props$onRemove === undefined ? function () {} : _props$onRemove;

    onRemove(this.field);
  };

  Field.prototype.createField = function createField() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var _props = this.props,
        name = _props.name,
        _props$value = _props.value,
        value = _props$value === undefined ? '' : _props$value,
        _props$validators = _props.validators,
        validators = _props$validators === undefined ? [] : _props$validators,
        _props$validatorsOpti = _props.validatorsOptions,
        validatorsOptions = _props$validatorsOpti === undefined ? {} : _props$validatorsOpti,
        _props$asyncValidator = _props.asyncValidator,
        asyncValidator = _props$asyncValidator === undefined ? null : _props$asyncValidator,
        _props$asyncValidator2 = _props.asyncValidatorOptions,
        asyncValidatorOptions = _props$asyncValidator2 === undefined ? {} : _props$asyncValidator2;

    var val = props.value !== undefined ? props.value : value;
    return new _fieldAttr.FieldAttr(this, name, val, validators, validatorsOptions, asyncValidator, asyncValidatorOptions);
  };

  Field.prototype.validateField = function validateField(event) {
    var _this2 = this;

    var _props$onAsyncValid = this.props.onAsyncValid,
        onAsyncValid = _props$onAsyncValid === undefined ? function () {} : _props$onAsyncValid;

    this.field.validate();
    this.field.asyncValidate(event, function (active) {
      active && onAsyncValid(_this2.field);
    });
  };

  Field.prototype.__onFocus__REACT_HOT_LOADER__ = function __onFocus__REACT_HOT_LOADER__(event) {
    var _props$onFocus = this.props.onFocus,
        onFocus = _props$onFocus === undefined ? function () {} : _props$onFocus;

    this.field.setFocus(true);
    this.validateField(_fieldAttr.FieldAttr.events.FOCUS);
    onFocus(this.field, event);
  };

  Field.prototype.__onBlur__REACT_HOT_LOADER__ = function __onBlur__REACT_HOT_LOADER__(event) {
    var _props$onBlur = this.props.onBlur,
        onBlur = _props$onBlur === undefined ? function () {} : _props$onBlur;

    this.field.setFocus(false);
    this.field.setTouched(true);
    this.validateField(_fieldAttr.FieldAttr.events.BLUR);
    onBlur(this.field, event);
  };

  Field.prototype.__onChange__REACT_HOT_LOADER__ = function __onChange__REACT_HOT_LOADER__(value, event) {
    var _props$onChange = this.props.onChange,
        onChange = _props$onChange === undefined ? function () {} : _props$onChange;

    this.field.setValue(value);
    this.field.setTouched(true);
    this.field.setDirty(true);
    this.validateField(_fieldAttr.FieldAttr.events.CHANGE);
    this.updateState();
    onChange(this.field, event);
  };

  Field.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__() {
    var _props$onUpdate = this.props.onUpdate,
        onUpdate = _props$onUpdate === undefined ? function () {} : _props$onUpdate;

    this.field.setDirty(true);
    this.validateField();
    onUpdate(this.field);
  };

  Field.prototype.__reset__REACT_HOT_LOADER__ = function __reset__REACT_HOT_LOADER__(value) {
    var _this3 = this;

    return new _promise2.default(function (resolve) {
      var _props$onInit2 = _this3.props.onInit,
          onInit = _props$onInit2 === undefined ? function () {} : _props$onInit2;

      _this3.field = _this3.createField({ value: value });
      _this3.setState({
        value: _this3.field.value
      }, function () {
        _this3.validateField();
        onInit(_this3.field);
        resolve(_this3.field);
      });
    });
  };

  Field.prototype.__updateState__REACT_HOT_LOADER__ = function __updateState__REACT_HOT_LOADER__() {
    this.setState({ value: this.field.value });
  };

  Field.prototype.render = function render() {
    var defaultComponent = _fields.FieldInput;
    var _props2 = this.props,
        component = _props2.component,
        type = _props2.type;
    var value = this.state.value;

    switch (type) {
      case 'checkbox':
        defaultComponent = _fields.FieldCheckbox;
        break;
      case 'radio':
        defaultComponent = _fields.FieldRadio;
        break;
    }
    return _react2.default.createElement(component || defaultComponent, (0, _extends3.default)({}, (0, _utils.getElementProps)(this.props), {
      onFocus: this.onFocus,
      onBlur: this.onBlur,
      onChange: this.onChange,
      value: value
    }));
  };

  return Field;
}(_react2.default.Component);

Field.propTypes = (0, _extends3.default)({}, _fieldProps.FieldProps, {
  onInit: _propTypes2.default.func,
  onUpdate: _propTypes2.default.func,
  onAsyncValid: _propTypes2.default.func
});

Field.Input = _fields.FieldInput;
Field.Radio = _fields.FieldRadio;
Field.Checkbox = _fields.FieldCheckbox;
Field.RadioGroup = _fields.FieldRadioGroup;
Field.CheckboxGroup = _fields.FieldCheckboxGroup;
Field.Select = _fields.FieldSelect;
Field.Text = _fields.FieldText;

exports.Field = Field;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Field, 'Field', 'E:/Projects/React/git/vb-react-form/src/field.js');
}();

;